//########################
//MapInfoデータをIllustratorドキュメントに再現します。
//Shapeファイルの場合の準備
//Shapeファイルをまずmifファイルに変換します。
//http://www.mmtm.tv/から
//Shp2Mif Converterをダウンロードしてshapeファイルを変換します。
//
//ドキュメントを開いておきスクリプトを実行するとmifファイルが入ったフォルダを聞いてきますので
//フォルダを指定してください。フォルダ内のmifファイル全てを処理します。ファイル名がレイヤー名になります。
//終了すると終了しましたのメッセージが出ます。
//
//うまくいかないときは拡大率や座標がアートボードからはみ出している場合も考えられます。
//下の値ぐらいに変更して試してみてください。
//var myper = 0.01;//拡大率
//var xoffset = 0;//X座標の移動値
//var yoffset = 0;//Y座標の移動値
//たけうちとおる
//########################
var myper = 0.05;//拡大率
var xoffset = 1000;//X座標の移動値
var yoffset = 7000;//Y座標の移動値

main();

function main(){
	if( app.documents.length == 0){
		alert("ドキュメントを開いて実行してください。");
		return;
	}
	folderObj = Folder.selectDialog("mifが入ったフォルダを選択してください");
	if(folderObj){
		var fileList = folderObj.getFiles("*.mif");//"*.jsx,*.scpt,*.vbs"
		//fileObj = new File(filename);
		for(N = 0;N < fileList.length; N++){
			var fileObj = fileList[N];
			openmif(fileObj);
		}
		alert("終了しました");
	}
}

function openmif(fileObj){
	var layerName = fileObj.displayName;
	flag = fileObj.open("r");
	if (flag == true){
		var myFlg = -2;
		while (!fileObj.eof){
			var mystr = fileObj.readln();
			//if(mystr.indexOf("Region") > 0 || mystr == "Region 1"){
			if(mystr.match("Region")){
				myFlg = -1;
			}else if(myFlg == -1){
				if(mystr != ""){
					var arycount = parseInt(mystr);
					var shapeAry = new Array(arycount-1);
					myFlg = 0;
				}
			}else if(myFlg > -1){
				if(mystr != ""){
					pointAry = mystr.split(" ");
					shapeAry[myFlg] = [eval(pointAry[0])*myper+xoffset,eval(pointAry[1])*myper+yoffset];
					myFlg++;
				}
				if(myFlg == arycount-1){
					makeshape(shapeAry,layerName);
				}else if(myFlg == arycount){
					myFlg = -1;
				}
			}
		}
		fileObj.close();
	}
}
function makeshape(myentirepath,layerName){
	var myColor = reColor( Math.floor(Math.random() * 100) + 1,Math.floor(Math.random() * 100) + 1,Math.floor(Math.random() * 100) + 1,0); //　赤色
	try{
		var layerObj = app.activeDocument.layers[layerName];
	}catch(err){
		var layerObj = app.activeDocument.layers.add();
		layerObj.name = layerName;
	}
	pObj = layerObj.pathItems.add();
	pObj.setEntirePath(myentirepath);
	pObj.filled =  true; //　塗りなし
	pObj.stroked = false; //　線あり
	pObj.fillColor = myColor; //　塗りの色を指定（赤色）
	pObj.closed = true;
	//pObj.strokeWidth = 3; //　線幅10ポイント
	//pObj.strokeColor = redColor; //　線の色を指定（赤色）
}

function reColor(C,M,Y,K){
	var myCMYK=new CMYKColor();
	//var myColor=new Color();
	
	myCMYK.cyan=C;
	myCMYK.magenta=M;
	myCMYK.yellow=Y;
	myCMYK.black=K;
	
	//myColor.cmyk=myCMYK;
	return myCMYK;
}